#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Apr 27 14:35:16 2020

@author: fredodurand
"""



import matplotlib.pyplot as plt
from matplotlib.widgets import Slider, Button, RadioButtons
import random
import numpy as np

# you probably need to change the properties of your spyder to get the real-time update of graphs: 
#Ipython console ->  backend -> automatic



#plt.xkcd(scale=1, length=100, randomness=2)


data_x = [1, 2, 3, 5, 6, 8]
data_y = [1, 4, 3.5, 8, 5, 8.5]
a = 2
b =-3

def apply_linear(a, b, data_x):
    return [a*x+b for x in data_x]

def error_plot(a, b, data_x, data_y):
    pred_y = apply_linear(a, b, data_x)
    lx = []
    ly = []
    for i in range(len(data_x)):
        x = data_x[i]
        lx.append(x)
        ly.append(data_y[i])
        lx.append(x)
        ly.append(pred_y[i])
        lx.append(None)
        ly.append(None)
    return lx, ly

fig, ax = plt.subplots()
plt.subplots_adjust(left=0.25, bottom=0.25)
#t = np.arange(0.0, 1.0, 0.001)

#s = a0 * np.sin(2 * np.pi * f0 * t)

# S, I, R = simulation_sir(beta, gamma, duration = 100)

plt.scatter (data_x, data_y, c="tab:blue")

l = plt.scatter(data_x, apply_linear(a, b, data_x), c="tab:orange")
lx, ly = error_plot(a, b, data_x, data_y)
l2, = plt.plot(lx, ly, c="tab:red")
endpoints_x = [data_x[0], data_x[-1]]
endpoints_y = apply_linear(a, b, endpoints_x)
l4, = plt.plot(endpoints_x, endpoints_y)

plt.title("Least squares")
plt.xlabel('y')
plt.ylabel('x')

def SSD (a, b, data_x, data_y):
    pred_y = apply_linear(a, b, data_x)
    dif = [pred_y[i]-data_y[i] for i in range(len(data_y))]
    dif2 = [x**2 for x in dif]
    return sum(dif2)


ssd_str = str(SSD(a, b, data_x, data_y))

t = plt.text(x = 1.1, y = endpoints_y[-1]*0.9, color = "tab:red", \
             s = 'Sum of square difference : '+ssd_str, weight = 'bold')

ax1 = plt.axes([0.25, 0.1, 0.65, 0.03])
ax2 = plt.axes([0.25, 0.05, 0.65, 0.03])

sa = Slider(ax1, 'a', -2.5, 2.5, valinit=a)
sb = Slider(ax2, 'b', -5, 10, valinit=b)


def update(val):
    a =sa.val
    b = sb.val

    A = np.array([data_x, apply_linear(a, b, data_x)])
    #print(A)
    l.set_offsets(A.T)
    
    lx, ly = error_plot(a, b, data_x, data_y)
    l2.set_ydata(ly)
    l2.set_xdata(lx)
    endpoints_y = apply_linear(a, b, endpoints_x)
    l4.set_ydata(endpoints_y)
    ssd_f = SSD(a, b, data_x, data_y)
    
    ssd_str = str((int(ssd_f*100))/100)

    t.set_text( 'Sum of square difference : '+ssd_str)

    fig.canvas.draw_idle()

sa.on_changed(update)
sb.on_changed(update)

plt.show()


